package com.xk72.charles.gui.settings;

import com.xk72.charles.config.UserInterfaceConfiguration;
import com.xk72.charles.gui.lib.FormUtils;
import com.xk72.charles.gui.settings.SettingsPanel;
import javax.swing.ButtonGroup;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import net.miginfocom.swing.MigLayout;

public class ViewersSettingsPanel extends SettingsPanel {

   private final JCheckBox bShowLineNumbers = new JCheckBox("显示行号");
   private final JCheckBox bLineWrap = new JCheckBox("自动换行");
   private final JRadioButton rSessionNavStructureHorizontal = new JRadioButton("高");
   private final JRadioButton rSessionNavStructureVertical = new JRadioButton("宽");
   private final JRadioButton rSessionNavSequenceVertical = new JRadioButton("宽");
   private final JCheckBox bCombineHeadersAndBodyViewers = new JCheckBox("合并标题和正文查看器");
   private final JCheckBox bCombineRequestAndResponse = new JCheckBox("合并请求和响应");
   private final JComboBox cTime;
   private final JComboBox cSpeed;
   private final JRadioButton rSessionNavSequenceHorizontal = new JRadioButton("高");


   public ViewersSettingsPanel() {
      super("检查");
      UserInterfaceConfiguration var1 = this.ctx.getConfiguration().getUserInterfaceConfiguration();
      this.bShowLineNumbers.setSelected(var1.isShowLineNumbers());
      this.bLineWrap.setSelected(var1.isLineWrap());
      ButtonGroup var2;
      (var2 = new ButtonGroup()).add(this.rSessionNavStructureHorizontal);
      var2.add(this.rSessionNavStructureVertical);
      this.rSessionNavStructureHorizontal.setSelected(var1.getSessionNavStructureLayout() == 0);
      this.rSessionNavStructureVertical.setSelected(var1.getSessionNavStructureLayout() == 1);
      (var2 = new ButtonGroup()).add(this.rSessionNavSequenceHorizontal);
      var2.add(this.rSessionNavSequenceVertical);
      this.rSessionNavSequenceHorizontal.setSelected(var1.getSessionNavSequenceLayout() == 0);
      this.rSessionNavSequenceVertical.setSelected(var1.getSessionNavSequenceLayout() == 1);
      this.bCombineHeadersAndBodyViewers.setSelected(var1.isCombineHeadersAndBody());
      this.bCombineRequestAndResponse.setSelected(var1.isCombineRequestAndResponse());
      this.cSpeed = new JComboBox();
      this.cSpeed.addItem("字节/秒");
      this.cSpeed.addItem("比特/秒");
      this.cSpeed.setSelectedIndex(var1.getUnitsSpeed());
      this.cTime = new JComboBox();
      this.cTime.addItem("分和秒");
      this.cTime.addItem("毫秒");
      this.cTime.setSelectedIndex(var1.getUnitsTime());
      JPanel var3;
      (var3 = new JPanel(new MigLayout("wrap, fillx, ins 0", "[label][fill][fill,grow]", "[]u[]"))).add(this.bCombineHeadersAndBodyViewers, "skip, span");
      var3.add(this.bCombineRequestAndResponse, "skip, span");
      var3.add(new JLabel("结构视图布局:"));
      var3.add(this.rSessionNavStructureHorizontal);
      var3.add(this.rSessionNavStructureVertical);
      var3.add(new JLabel("序列视图布局:"));
      var3.add(this.rSessionNavSequenceHorizontal);
      var3.add(this.rSessionNavSequenceVertical);
      FormUtils.FwRs(var3);
      var3.add(this.bShowLineNumbers, "skip, span");
      var3.add(this.bLineWrap, "skip, span");
      FormUtils.FwRs(var3);
      var3.add(new JLabel("速度:"));
      var3.add(this.cSpeed, "span");
      var3.add(new JLabel("时间:"));
      var3.add(this.cTime, "span");
      this.add(var3);
   }

   public static void main(String[] var0) {
      (new ViewersSettingsPanel()).test();
   }

   public boolean save() {
      UserInterfaceConfiguration var1;
      (var1 = this.ctx.getConfiguration().getUserInterfaceConfiguration()).setShowLineNumbers(this.bShowLineNumbers.isSelected());
      var1.setLineWrap(this.bLineWrap.isSelected());
      var1.setSessionNavStructureLayout(this.rSessionNavStructureHorizontal.isSelected()?0:1);
      var1.setSessionNavSequenceLayout(this.rSessionNavSequenceHorizontal.isSelected()?0:1);
      var1.setCombineHeadersAndBody(this.bCombineHeadersAndBodyViewers.isSelected());
      var1.setCombineRequestAndResponse(this.bCombineRequestAndResponse.isSelected());
      var1.setUnitsSpeed(this.cSpeed.getSelectedIndex());
      var1.setUnitsTime(this.cTime.getSelectedIndex());
      return true;
   }
}
